﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Charting;
using Telerik.WinControls.UI;

namespace _823594
{
    public partial class Form1 : Form
    {
        BindingList<ChartBusinessObject> myList;
        BindingList<ChartBusinessObject> myList1;
        Timer t = new Timer();
       
        Random r = new Random();

        public Form1()
        {
            InitializeComponent();
            this.radChartView1.AreaType = ChartAreaType.Polar;
            this.radChartView1.CreateRenderer += new ChartViewCreateRendererEventHandler(radChartView1_CreateRenderer);
        }
        void radChartView1_CreateRenderer(object sender, ChartViewCreateRendererEventArgs e)
        {
           e.Renderer = new CustomCartesianRenderer(e.Area as PolarArea);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            t.Tick += t_Tick;
            t.Interval = 1000;
            t.Start();

            
            this.radChartView1.ShowGrid = true;
            //  PolarGrid grid = this.radChartView1.Area.GetGrid<PolarGrid>();
            // grid.ForeColor = Color.Red;

            // radChartView1.ChartElement.Image = Image.FromFile(@"C:\Users\karamfilov\Downloads\the_music_icon.png");

            RadarLineSeries series = new RadarLineSeries();
            series.Spline = true;

            //  series.BorderColor = Color.DarkKhaki;
            //  series.BorderWidth = 5;

            //series.ShowLabels = true;
            //series.DrawLinesToLabels = true;



            myList = new BindingList<ChartBusinessObject>();

            myList.Add(new ChartBusinessObject("Oranges", r.Next(10)));
            myList.Add(new ChartBusinessObject("Apples", r.Next(10)));
            myList.Add(new ChartBusinessObject("Bananas", r.Next(10)));

            series.DataSource = myList;
            series.CategoryMember = "Category";
            series.ValueMember = "Value";
            radChartView1.Series.Add(series);

            series = new RadarAreaSeries();


            myList1 = new BindingList<ChartBusinessObject>();

            myList1.Add(new ChartBusinessObject("Oranges", r.Next(10)));
            myList1.Add(new ChartBusinessObject("Apples", r.Next(10)));
            myList1.Add(new ChartBusinessObject("Apples1", r.Next(10)));
            myList1.Add(new ChartBusinessObject("Apples2", r.Next(10)));
            myList1.Add(new ChartBusinessObject("Bananas", r.Next(10)));

            series.DataSource = myList1;
            series.CategoryMember = "Category";
            series.ValueMember = "Value";
            //radChartView1.Series.Add(series);
          
        }

        void t_Tick(object sender, EventArgs e)
        {
            myList[0].Value = r.Next(1);
            myList[1].Value = r.Next(5);
            myList[1].Value = r.Next(5);
            myList[1].Value = r.Next(5);
            myList[2].Value = r.Next(4,5);

            //myList1[0].Value = r.Next(10);
            //myList1[1].Value = r.Next(10);
            //myList1[2].Value = r.Next(10);
        }
    }
    public class CustomCartesianRenderer : PolarRenderer
    {
        public CustomCartesianRenderer(PolarArea area)
            : base(area)
        { }

        protected override void Initialize()
        {
            base.Initialize();

            for (int i = 0; i < this.DrawParts.Count; i++)
            {
                RadarLineSeriesDrawPart linePart = this.DrawParts[i] as RadarLineSeriesDrawPart;
                if (linePart != null)
                {
                   this.DrawParts[i] = new CustomLineSeriesDrawPart((RadarLineSeries)linePart.Element, this);
                }
            }
        }
    }
    public class CustomLineSeriesDrawPart : RadarLineSeriesDrawPart
    {
        float[] predefinedValues = new float[] {0, 1, 2, 3, 4, 5};
        Color[] predefinedColors = new Color[] {Color.LightGreen, Color.Green, Color.Yellow ,Color.Orange,Color.Red, Color.DarkRed };

        public CustomLineSeriesDrawPart(RadarLineSeries series, IChartRenderer renderer)
            : base(series, renderer)
        { }

        protected override void DrawLine()
        {
            RadarLineSeries series = this.Element as RadarLineSeries;
            if (series.DataPoints.Count < 2)
            {
                return;
            }

            RectangleF rect = this.Element.Bounds;
            rect.Offset(this.OffsetX, this.OffsetY);
            if (rect.IsEmpty)
            {
                return;
            }

            GraphicsPath path = GetLinePath();
            LinearGradientBrush linearBrush = new LinearGradientBrush(rect, Color.Transparent, Color.Transparent, 0f);

            ColorPositionBlend colorPositionBlend = GetColorPositionBlend(series.DataPoints);
            System.Drawing.Drawing2D.ColorBlend blend = new System.Drawing.Drawing2D.ColorBlend();
            blend.Positions = colorPositionBlend.Positions;
            blend.Colors = colorPositionBlend.Colors;
            linearBrush.InterpolationColors = blend;

            Graphics graphics = this.Renderer.Surface as Graphics;
            graphics.SmoothingMode = SmoothingMode.AntiAlias;
            graphics.DrawPath(new Pen(linearBrush, 3), path);
        }

        private ColorPositionBlend GetColorPositionBlend(ChartDataPointCollection dataPoints)
        {
            ColorPositionBlend blend = new ColorPositionBlend();
            decimal majorStep = 1m / (dataPoints.Count - 1);

            for (int i = 0; i < dataPoints.Count; i++)
            {
                float position = (float)(i * majorStep);
                Color color = GetValueColor((double)((CategoricalDataPoint)dataPoints[i]).Value);
                blend.Add(color, position);

                if (i < dataPoints.Count - 1)
                {
                    double currentValue = (double)((CategoricalDataPoint)dataPoints[i]).Value;
                    double nextValue = (double)((CategoricalDataPoint)dataPoints[i + 1]).Value;

                    ColorPositionBlend additionalBlends = GetAdditionalColorPositionBlend(currentValue, nextValue, majorStep, i);
                    blend.Add(additionalBlends);
                }
            }
            return blend;
        }

        private ColorPositionBlend GetAdditionalColorPositionBlend(double currentValue, double nextValue, decimal majorStep, int iteration)
        {
            ColorPositionBlend blend = new ColorPositionBlend();

            if (currentValue < nextValue)
            {
                for (int j = 0; j < predefinedValues.Length; j++)
                {
                    float colorValue = predefinedValues[j];
                    if (currentValue < colorValue && colorValue < nextValue)
                    {
                        float additionalPosition = (float)(iteration * majorStep) + (float)((colorValue - currentValue) / (nextValue - currentValue)) * (float)(majorStep);
                        Color additionalColor = GetValueColor(colorValue);
                        blend.Add(additionalColor, additionalPosition);
                    }
                }
            }

            if (currentValue > nextValue)
            {
                for (int j = predefinedValues.Length - 1; j >= 0; j--)
                {
                    float colorValue = predefinedValues[j];
                    if (currentValue > colorValue && colorValue > nextValue)
                    {
                        float additionalPosition = (float)(iteration * majorStep) + (float)((currentValue - colorValue) / (currentValue - nextValue)) * (float)(majorStep);
                        Color additionalColor = GetValueColor(colorValue);
                        blend.Add(additionalColor, additionalPosition);
                    }
                }
            }

            return blend;
        }

        private Color GetValueColor(double value)
        {
            if (value <= predefinedValues[0])
            {
                return predefinedColors[0];
            }

            if (value >= predefinedValues[predefinedValues.Length - 1])
            {
                return predefinedColors[predefinedValues.Length - 1];
            }

            for (int i = 0; i < predefinedValues.Length - 1; i++)
            {
                if (predefinedValues[i] <= value && value <= predefinedValues[i + 1])
                {
                    double c = (predefinedValues[i + 1] - value) / (predefinedValues[i + 1] - predefinedValues[i]);
                    return Color.FromArgb((int)(predefinedColors[i].R * c + predefinedColors[i + 1].R * (1 - c)),
                                          (int)(predefinedColors[i].G * c + predefinedColors[i + 1].G * (1 - c)),
                                          (int)(predefinedColors[i].B * c + predefinedColors[i + 1].B * (1 - c)));
                }
            }

            return Color.Transparent;
        }
    }
    public class ColorPositionBlend
    {
        private List<float> positions;
        private List<Color> colors;

        public ColorPositionBlend()
        {
            positions = new List<float>();
            colors = new List<Color>();
        }

        public void Add(Color color, float position)
        {
            this.colors.Add(color);
            this.positions.Add(position);
        }

        public void Add(ColorPositionBlend colorPositionBlend)
        {
            this.positions.AddRange(colorPositionBlend.positions);
            this.colors.AddRange(colorPositionBlend.colors);
        }

        public float[] Positions
        {
            get { return this.positions.ToArray(); }
        }

        public Color[] Colors
        {
            get { return this.colors.ToArray(); }
        }
    }

    class ChartBusinessObject : INotifyPropertyChanged
    {
        private double value;
        private string category;

        public ChartBusinessObject(string category, double value)
        {
            this.value = value;
            this.category = category;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public double Value
        {
            get
            {
                return this.value;
            }
            set
            {
                this.value = value;
                OnPropertyChanged("Value");
            }
        }

        public string Category
        {
            get
            {
                return this.category;
            }
            set
            {
                this.category = value;
            }
        }
    }
}